SystemOrganization addCategory: #'Seaside-Flow'!

!WAPainterVisitor methodsFor: '*seaside-flow' stamp: 'jf 2/8/2009 10:52'!
visitTask: aTask
	self visitComponent: aTask! !

WAPainterVisitor subclass: #WATaskVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Flow'!

!WATaskVisitor methodsFor: 'visiting' stamp: 'jf 2/8/2009 23:38'!
visitTask: aTask
	super visitTask: aTask.
	aTask isExecuting ifFalse: [
		[ aTask execute ]
			on: WARenderNotification
			do: [ :n | ] ]! !

WAActionPhaseContinuation subclass: #WAFlowActionPhaseContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Flow'!

!WAFlowActionPhaseContinuation methodsFor: 'processing' stamp: 'jf 2/20/2009 11:58'!
runCallbacks
	super runCallbacks.
	(WAVisiblePresenterGuide client: (WATaskVisitor new)) start: self presenter.! !

!GRPlatform methodsFor: '*seaside-flow' stamp: 'jf 2/13/2009 15:53'!
suspendFlowDo: aBlock
	"Evaluate aBlock, passing in a continuation that can be evaluated to answer to the place where this very method was called. This method is presumed to be executed only within the scope of an executing Callback or Task and should, ideally, create a continuation that includes only the contexts that make up the Callback or Task execution (a partial or delimited continuation). Do not use this method, if you don't understand this comment."
	self subclassResponsibility! !

!WARequestContext methodsFor: '*seaside-flow' stamp: 'jf 1/21/2009 10:51'!
redirect
	^ self respondAndContinue: [ :url | self redirectTo: url ]! !

!WARequestContext methodsFor: '*seaside-flow' stamp: 'lr 2/20/2009 11:06'!
redirectWithMessage: aString delay: aNumber 
	self respondAndContinue: [ :url | 
		self responseGenerator 
			refreshAfter: aNumber
			location: url
			message: aString ]! !

!WARequestContext methodsFor: '*seaside-flow' stamp: 'jf 9/30/2009 00:19'!
respondAndContinue: aBlock 
	^ GRPlatform current suspendFlowDo: 
		[ :cc | 
		aBlock value: (self session actionUrlForContinuation: cc).
		self respond ]! !

WARenderLoopMain subclass: #WAFlowMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Flow'!

!WAFlowMain class methodsFor: 'class initialization' stamp: 'jf 2/8/2009 15:53'!
initialize
	WAAdmin applicationDefaults
		at: #mainClass put: WAFlowMain;
		at: #actionPhaseContinuationClass put: WAFlowActionPhaseContinuation! !

!WAFlowMain methodsFor: 'processing' stamp: 'jf 2/8/2009 14:54'!
prepareRoot: aComponent
	super prepareRoot: aComponent.
	(WAVisiblePresenterGuide client: (WATaskVisitor new)) start: aComponent! !

!WASession methodsFor: '*seaside-flow' stamp: 'jf 9/30/2009 01:02'!
respond: aBlock 
	self 
		greaseDeprecatedApi: 'WASession>>#respond:'
		details: 'Use WARequestContext>>#respondAndContinue: (requires the Seaside-Flow package).'.
	^ self requestContext respondAndContinue: aBlock! !

!WAComponent methodsFor: '*seaside-flow-filters' stamp: 'lr 8/31/2008 14:30'!
authenticateWith: anAuthenticator during: aBlock
	"Authenticate calls during the evaluation of aBlock."
	
	self 
		filterWith: (WAAuthenticationFilter new
			authenticator: anAuthenticator;
			yourself)
		during: aBlock! !

!WAComponent methodsFor: '*seaside-flow' stamp: 'lr 1/24/2009 21:00'!
call: aComponent 
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. Code can return from here later on by sending #answer: to aComponent."

	^ self wait: [ :cc | self show: aComponent onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 1/24/2009 21:03'!
chooseFrom: aCollection
	"Choose an item from the given aCollection. Answer the selected item."

	^ self wait: [ :cc | self chooseFrom: aCollection onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 1/24/2009 21:04'!
chooseFrom: aCollection caption: aString
	"Choose an item from the given aCollection with caption aString. Answer the selected item."
	
	^ self wait: [ :cc | self chooseFrom: aCollection caption: aString onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 8/3/2009 20:23'!
chooseFrom: aCollection default: anObject
	"Choose an item from the given aCollection and the default anObject. Answer the selected item."

	^ self wait: [ :cc | self chooseFrom: aCollection default: anObject onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 8/3/2009 20:24'!
chooseFrom: aCollection default: anObject caption: aString
	"Choose an item from the given aCollection, the default anObject and the caption aString. Answer the selected item."
	
	^ self wait: [ :cc | self chooseFrom: aCollection default: anObject caption: aString onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 1/24/2009 21:04'!
confirm: aString
	"Display a yes/no dialog with caption aString. Answer true if the response is yes, false if no."

	^ self wait: [ :cc | self confirm: aString onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-filters' stamp: 'lr 8/31/2008 14:12'!
filterWith: aFilter during: aBlock
	| answer |
	self session addFilter: aFilter.
	answer := aBlock value.
	self session removeFilter: aFilter.
	^ answer! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 1/24/2009 21:04'!
inform: aString
	"Display a dialog with aString to the user until he clicks the ok button."

	^ self wait: [ :cc | self inform: aString onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-filters' stamp: 'lr 8/31/2008 14:31'!
isolate: aBlock
	"Isolate pages called from within aBlock. If aBlock is left, the backbutton can't be used to go back and trigger actions on these pages."
	
	| filter result |
	filter := WATransactionFilter new.
	result := self filterWith: filter during: aBlock.
	filter close.
	^ result! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 1/24/2009 21:05'!
request: aRequestString
	"Display an input dialog with the question aRequestString. Answer the string the user enters."

	^ self wait: [ :cc | self request: aRequestString onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 1/24/2009 21:05'!
request: aRequestString default: aDefaultString
	"Display an input dialog with the question aRequestString and the default string aDefaultString. Answer the string the user enters."
	
	^ self wait: [ :cc | self request: aRequestString default: aDefaultString onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 1/24/2009 21:05'!
request: aRequestString label: aLabelString
	"Display an input dialog with the question aRequestString and the button label aLabelString. Answer the string the user enters."
	
	^ self wait: [ :cc | self request: aRequestString label: aLabelString onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow-dialog' stamp: 'lr 1/24/2009 21:05'!
request: aRequestString label: aLabelString default: aDefaultString
	"Display an input dialog with the question aRequestString, the button label aLabelString and the default string aDefaultString. Answer the string the user enters."

	^ self wait: [ :cc | self request: aRequestString label: aLabelString default: aDefaultString onAnswer: cc ]! !

!WAComponent methodsFor: '*seaside-flow' stamp: 'jf 9/30/2009 00:19'!
wait: aBlock 
	"Evaluate aBlock and pass in a continuation that can be evaluated to answer to the place where this very method was called. Note that after evaluating aBlock a re-rendering of the receiver is enfored. Do not use this method, if you don't understand this comment."
	^ GRPlatform current suspendFlowDo: 
		[ :cc | 
		aBlock value: cc.
		WARenderNotification signal ]! !

WAComponent subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Flow'!

!WATask commentStamp: 'pmm 6/30/2007 19:02' prior: 0!
I am a subclass of WAComponent, specialized for defining workflow.  The difference between a task and a component is the following:

Both of them are reusable, embeddable, callable pieces of user interface. A component has state (instance variables), behavior (it may change its state, and it may also choose to display other components with #call:), and appearance (it renders HTML). A Task has only the first two - it doesn't render any HTML directly, but only through the components it calls. This is useful when what you want to encapsulate/embed/call is purely a process (show this component, then this one, then this one).

The key method for WATask is #go - as soon as a task is displayed, this method will get invoked, and will presumably #call: other components.

In terms of implementation, you can think of a WATask in the following way: it is a component which renders two things:
- a link whose callback invokes the #go method
- a header that immediately redirects to the URL of that link

Subclasses must not implement #renderContentOn:

An example can be found in WAConvenienceTest.
!

!WATask methodsFor: 'visiting' stamp: 'jf 2/8/2009 10:53'!
accept: aVisitor
	aVisitor visitTask: self! !

!WATask methodsFor: 'running' stamp: 'jf 2/9/2009 00:34'!
execute
	"Internal method to start the task running. DO NOT OVERRIDE THIS METHOD!! Subclasses
	should implement #go to specify behaviour.
	In order to prevent looping infinitely when #go does not make a #call:, we cache
	the identity hash of the request context and make sure it has changed in the next
	loop iteration."
	
	| hash |
	hash := nil.
	[ (hash = self requestContext identityHash)
			ifTrue: [ WATaskInfiniteLoop signal: 'Infinite loop detected while executing a task.' ]
			ifFalse: [ hash := self requestContext identityHash ].
	self answer: self go ] repeat! !

!WATask methodsFor: 'running' stamp: 'jf 11/10/2003 16:13'!
go
	self subclassResponsibility! !

!WATask methodsFor: 'testing' stamp: 'jf 2/8/2009 23:44'!
isExecuting
	"Answer whether or not the task is currently executing."
	
	^ (self activeComponent == self) not! !

!WATask methodsFor: 'rendering' stamp: 'lr 4/30/2009 19:17'!
renderContentOn: html
	"Tasks define behaviour and should not render themselves directly. Behaviour is defined
	in the #go method, which can use #call: and other methods to display components.
	
	In general, if this method is called, it means that the application has not been configured
	properly to use Flow and the task was never executed."

	WATaskNotDelegated signal: 'This task has no delegation.'	! !

!GRPackage class methodsFor: '*seaside-flow' stamp: 'jf 3/15/2009 19:48'!
seasideFlow
	^ self new
		name: 'Seaside-Flow';
		description: 'Define control flow as a continuous piece of code, with natural, linear control flow.';
		addDependency: 'Seaside-Core'; "Methods are added to WARequestContext"
		addDependency: 'Seaside-Component'; "Methods are added to WAComponent"
		addDependency: 'Seaside-RenderLoop'; "Methods are added to WASession that depend on RenderLoop"
		addDependency: 'Seaside-Tools-Core'; "We currently us WAFlowMain class>>initialize to configure the application defaults to use our Main and ActionPhaseContinuation"
		yourself! !

WAError subclass: #WATaskInfiniteLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Flow'!

!WATaskInfiniteLoop methodsFor: 'accessing' stamp: 'jf 2/20/2009 18:09'!
seasidePossibleCauses
	^ #(
		'The Task has an empty #go method.'
		'The Task does not call another Component in its #go method.'
		'The #go method is written to depend on the looping execution of Tasks. If looping behaviour is needed by he Task before calling a Component, the loop should be implemented within the #go method.'
	)! !

WAError subclass: #WATaskNotDelegated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Flow'!

!WATaskNotDelegated methodsFor: 'accessing' stamp: 'jf 2/20/2009 18:09'!
seasidePossibleCauses
	^#(
		'The Task is embedded in another Component but has not been included in the list of child Components returned by the Component''s #children method.'
		'The application is not configured to use the Seaside-Flow package and the Task has not been executed.'
	)! !
WAFlowMain initialize!
